#ifndef	_DialogUtils_
#define _DialogUtils_

#include <string.h>
#include <ctype.h>
#include <StringUtils.h>

#define	NO_EDIT_TEXT	-1
#define	NO_SELECT_ITEM	-1
#define MAX_ITEM_CHARS	32767

#define	ESCAPE			0x1B
#define	DOT				'.'
#define	CUT_CHAR		'x'
#define	COPY_CHAR		'c'
#define	PASTE_CHAR		'v'

#ifndef	NIL
#define	NIL	0L
#endif	NIL
#define	DialogReturn(dp, Good)	{ DisposDialog(dp); dp=NIL; return(Good); }

				OutlineButton(DialogPtr dp,int  itemNo);
pascal	void	OutlineRoutine(WindowPtr wp, int itemNo);
				MakeUserItemOutline(DialogPtr dp, int itemNo);
		char	GetOtherKeyboardChar(char c);
		Boolean	ActiveDlogControl(WindowPtr wp, Handle item, int itemType,
					Rect *pbox, char *ps);
				SetCheckCharIfNoCommand(Boolean TurnItOn);
				SetCKF_Filter(Boolean (*EventFilterProc)());
				ClickButton(ControlHandle ch);
pascal	Boolean	CommandKeyFilter(DialogPtr dp, EventRecord *theEvent,
						int *itemHit);
		int		HandleDialog(DialogPtr dp, int SelectItemNo, int StopItem,
						int OutlineItem,
						Boolean (*EventFilterProc)(),
						Boolean (*ItemFilterProc)(),
						Boolean (*CloseRoutine)());
				mySelItemText(DialogPtr dp, int itemNo);
				mySetItemText(DialogPtr dp, int itemNo, char *ps);
				myGetItemText(DialogPtr dp, int itemNo, char *ps);
				mySetItemLong(DialogPtr dp,int itemNo,long l);
		Boolean	myGetItemLong(DialogPtr dp, int itemNo, long *pl);
				mySetItemFloat(DialogPtr dp, int itemNo, double f,int prec);
		Boolean	myGetItemFloat(DialogPtr dp, int itemNo, double *pf);
				mySetItemCtlValue(DialogPtr dp, int itemNo, int theValue);
		int		myGetItemCtlValue(DialogPtr dp, int  itemNo);
				myDisableCtlItem(DialogPtr dp, int  itemNo);
				myEnableCtlItem(DialogPtr dp, int  itemNo);
		Boolean SimpleOpenDialog(OSType OpenFileType, int *vRef, char *fname);
		Boolean SimpleSaveAsDialog(char *prompt, int *vRef, char *fname);
		int		AddDItem(int DLogID, Boolean FirstOne, int itemType,
						Rect *pItemRect, char *title);
		int		AddDResItem(int DLogID, Boolean FirstOne, int itemType,
						Rect *pItemRect, int resID);
				ReleaseDialogResources(DialogTHndl dth);

#endif _DialogUtils_
