/*
#include <QuickDraw.h>
*/
#include <stdio.h>
#include <GeneralUtils.h>
#include <StringUtils.h>
#include <DialogUtils.h>
#include <ScrollValBar.h>

SetUpWindow(void);
int HandleScrollDialog(DialogPtr dp, int SelectItemNo, int StopItem,
		int OutlineItem);
SetPhaseString(int Phase, char *PhaseString);
SetDialogPhases(ControlHandle ch);
main(void);

WindowPtr	bullseyeWindow;
Rect		dragRect;
Rect		windowBounds = { 40, 40, 165, 350 };

Rect		r;
ControlHandle	DDch;

/*
InitMacintosh()

{
	MaxApplZone();
	InitGraf(&thePort);
	InitFonts();
	FlushEvents(everyEvent, 0);
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(0L);
	InitCursor();
}
*/

SetUpWindow()

{
	dragRect = screenBits.bounds;
	
	bullseyeWindow = NewWindow(0L, &windowBounds, "\pBullseye", true, noGrowDocProc, -1L, true, 0);
	SetPort(bullseyeWindow);
}


int	HandleScrollDialog(dp, SelectItemNo, StopItem, OutlineItem)
	DialogPtr dp;
	int SelectItemNo, StopItem, OutlineItem;
{
	int		itemHit = StopItem+1; /* Initial value to enter loop */
	int 	itemNo, itemType, otherItemType;
	Handle	item, otherItem;
	Rect	box, otherBox;
	int		i;
	Boolean	GroupedRadioButtons;
int theVal;
Str255 s1, s2;

	SetPort(dp);

	if (SelectItemNo != NO_SELECT_ITEM)
		SelIText(dp, SelectItemNo, 0, MAX_ITEM_CHARS);

	ShowWindow(dp);
	if (OutlineItem == 1)
		OutlineButton(dp, 1);
	else if (OutlineItem > 1)
		MakeUserItemOutline(dp, OutlineItem);
	while(itemHit>StopItem) {
		ModalDialog(&CommandKeyFilter, &itemHit);
		GetDItem(dp, itemHit, &itemType, &item, &box);
		if (itemHit == 8)
			SetCtlValue(DDch, -50);
		if (itemHit == 9)
			SetCtlValue(DDch, (**DDch).contrlMax);
		switch (itemType) {
			case (ctrlItem + chkCtrl):
				SetCtlValue(item, (int) (GetCtlValue(item) == 0) );
				break;
			case (ctrlItem + radCtrl):
				GroupedRadioButtons = FALSE;
				for(i=itemHit-1; i>0; --i) {
					GetDItem(dp, i, &otherItemType, &otherItem, &otherBox);
					if (otherItemType == ctrlItem + radCtrl) {
						GroupedRadioButtons = TRUE;
						SetCtlValue(otherItem, 0);
					}
					else break;
				}
				for(i=itemHit+1; i<= *( (int *) (*(*((DialogPeek) dp)).items))+1; ++i) {
					GetDItem(dp, i, &otherItemType, &otherItem, &otherBox);
					if (otherItemType == ctrlItem + radCtrl) {
						GroupedRadioButtons = TRUE;
						SetCtlValue(otherItem, 0);
					}
					else break;
				}
				if (GroupedRadioButtons)
					SetCtlValue(item, 1);
				else
					SetCtlValue(item, (int) (GetCtlValue(item) == 0) );
				break;
		}
	}
	HideWindow(dp);
	return(itemHit);
}

SetPhaseString(int Phase, char *PhaseString)
/*	Converts Phase/100.0 to string; only works for <=3 digit Phase */
{
	int	i=0;

	if (Phase<0) {
		PhaseString[++i] = '-';
		Phase = -Phase;
	}
	PhaseString[++i] = '0' + Phase/100;
	if (Phase % 100 != 0) {
		PhaseString[++i] = '.';
		PhaseString[++i] = '0' + ( Phase/10 % 10 );
		if (Phase % 10 != 0)
			PhaseString[++i] = '0' + Phase % 10;
	}
	PhaseString[0] = i;
}

DialogPtr		dp;
SetDialogPhases(ControlHandle ch)
{
	int		thePhase = GetCtlValue(ch);
	Str255	ps;

	SetPhaseString(thePhase, (char *) ps);
	mySetIText(dp, 12, (char *) ps);

	SetPhaseString(thePhase+100, (char *) ps);
	mySetIText(dp, 13, (char *) ps);
}

main()
{
	int		y=0;
	Str255	st;
	char	*t = (char *) &st;
	double	f1;
Rect			tmpRect = {100, 100, 116, 200};
ControlHandle	ch;
int				type;
Handle			item;
Rect			box;
ProcPtr			DDpp;
int				PhaseStart;
Str255			PStartString, PEndString;

	InitMacintosh();
	SetUpWindow();

	if (sscanf(" 0.011", "%*s%5lf", &f1) > 0) {
		sprintf(t,"%g", f1);
		CtoPstr(t);
		MoveTo(5, 20*++y);
		DrawString(t);
	}

	PhaseStart = 0;
	dp =GetNewDialog(502, NIL, -1L);
	GetDItem(dp, 5, &type, &item, &box);
	if (type & 4) {
		DisposeControl((ControlHandle) item);
		DDch = NewControl(dp, &box, "\P", TRUE,
				PhaseStart, -100, 0, pushButProc, (long) &SetDialogPhases);
		DDpp = (ProcPtr) &SVB_Control;
		(**DDch).contrlDefProc = (Handle) &DDpp;
		SVB_Control(0, DDch, initCntl, 0L);
		SetCRefCon(DDch, (10L << 16) | (1L) );
		SetDItem(dp, 5, ctrlItem+resCtrl, (Handle) DDch, &box);
	}
	HandleScrollDialog(dp, NO_SELECT_ITEM,  2,3);

	while(!Button()) ;
}
