/*
 *	KludgyZoomWindow.c
 */

/*	Developed for following problem, which eventually went away,
 *	in Bouncing Ball program:
 *	For some reason, ZoomWindow caused intermittent freezes (mouse froze
 *	too), but only when called while iterating in the program.
 *	I checked values of all arguments, userState and stdState, spareFlag,
 *	etc., and everything seemed to be in order.  Tried TRUE for 3rd arg.
 *	as well.
 *				-TA 3/21/90
 */

#include "KludgyZoomWindow.h"

KludgyZoomWindow(WindowPtr WhichWindow, int Part, Boolean BringToFront)
{
	Rect		tr;

	if (BringToFront)	SelectWindow(WhichWindow);

	if (Part == inZoomOut)
		tr = (*((WStateData *) *(((WindowPeek) WhichWindow)->dataHandle))).stdState;
	else if (Part == inZoomIn)
		tr = (*((WStateData *) *(((WindowPeek) WhichWindow)->dataHandle))).userState;
	else return;

	ShowHide(WhichWindow, FALSE);
	MoveWindow(WhichWindow, tr.left, tr.top, FALSE);
	SizeWindow(WhichWindow, tr.right-tr.left, tr.bottom-tr.top, TRUE);
	ShowHide(WhichWindow, TRUE);

	/*	Reverse order of MoveWindow and SizeWindow for inZoomIn if
	 *	you dont ShowHide(..., FALSE) first.
	 */
}
