/*
 *	MathUtils.h
 *	Includes math utilities I often use.
 */

#ifndef	_MathUtils_
#define _MathUtils_

#define	PI				3.14159265358979323846
#define	EffectiveZero	1.0e-14
#define	INFINITY		(HUGE_VAL)
#define	NEG_INFINITY	(-HUGE_VAL)

	int		Sign(double d);
	int		RoundToInt(double d);
	double	Round(double d, int i);
			Round2Doubles(double d1, double d2, int Places,
					double *f1, double *f2);

#endif _MathUtils_