/*	ScrollValBar.h
 *	Control Definition function for a dark dial
 */

#ifndef	_ScrollValBar_
#define	_ScrollValBar_

#define	DRAW_WHOLE_CONTROL	0
#define	DRAW_INDICATOR		128

typedef struct {
			Rect		UpButton, DownButton, IndicatorRange;
			Rect		Thumb, PageUp, PageDown;
			PolyHandle	UpButtonPoly, DownButtonPoly;
			int			ThumbPos, ThumbExtent;
			ProcPtr		IndicatorFilterProc;
			Pattern		ArrowPat, IndRangePat;
}	ScrollValBarAreas, *pSVBAreas;

typedef struct {
		Rect	limitRect, slopRect;
		int		axis;
} *pThumbConstraints;


					SetSVBIndicatorRects(ControlHandle ch);
					DrawScrollValBar(ControlHandle ch, int partCode);
					InitializeSVBAreas(ControlHandle ch);
					DisposeSVBAreas(ControlHandle ch);
			int		TestSVBControl(ControlHandle ch, long LongPoint);
					CalcSVBRegions(ControlHandle ch, RgnHandle rh);
					PositionThumb(ControlHandle ch, long param);
					CalcThumbConstraints(ControlHandle ch, long param);
			int		SetRelScrollVal(ControlHandle ch, int dhv);
					SVBAutoTrack(ControlHandle ch, int partCode);
	pascal	long	SVB_Control(int varCode, ControlHandle ch, int msg,
							long param);

#endif _ScrollValBar_