/*	TextUtils.c: TextEdit Utilities
 *	-TA 6/26/90
 */

#include "TextUtils.h"

SetStdTextAttributes()
{
	TextFont(monaco);
	TextFace(PLAIN_TEXT);
	TextMode(srcOr);
	TextSize(9);
}

SetSameTextAttributes(TEHandle teh)
{
	TextFont((**teh).txFont);
	TextFace((**teh).txFace);
	TextMode((**teh).txMode);
	TextSize((**teh).txSize);
}

AppendChar(char c, TEHandle teH)
{
	TEInsert(&c /*+1L*/, 1L, teH);
}

AppendText(char *s, TEHandle teH)
{
	TEInsert(&(s[1]), (long) (s[0]), teH);
}

AppendTextLn(char *s, TEHandle teH)
{
	AppendText(s, teH);
	AppendChar(ReturnChar, teH);
}

AppendPadFloat(double d, int fw, int prec, Boolean ToPad, TEHandle teH)
{
	Str255	s;

	PadFtoStr(d, (char *) &s, fw, prec, ToPad);
	AppendText((char *) &s, teH);
}

AppendDecFloat(double d, int fw, int prec, int dec, Boolean ToPad,
		Boolean ToPadRight, TEHandle teH)
{
	Str255	s;

	PadFtoStrDec(d, (char *) &s, fw, prec, dec, ToPad, ToPadRight);
	AppendText((char *) &s, teH);
}
