#include "bbPrototypes.h"
#include "bbDebug.h"

Handle	Mother;
Size	MemAmount, MemGrow;
long	MotherSize = 0L, MotherSizeIncrement = 0L;


Error2Longs(long l1, long l2)
{
	Str255	s1, s2;

	sprintf(CP(s1), "%ld", l1);	sprintf(CP(s2), "%ld", l2);
	CtoPstr(CP(s1));		CtoPstr(CP(s2));
/*
	NumToString(l1, &s1); NumToString(l2, &s2);
*/
	ErrorAlert(CP(s1), "\P ", CP(s2), "\P");
}

SetMother()
{
	if (Mother != NIL) DisposHandle(Mother);
	MemAmount = MaxMem(&MemGrow);
	MotherSize += MotherSizeIncrement;
	Mother = NewHandle(MotherSize);
	if ((long) Mother == NIL) ERROR("\PNot enough memory for mother");
}
