/*	qmIteration.h
 *
 *	Definitions, Types to iterate different sets of vars
 *	(normal, bifurcation diagram)
 *
 *		-TA 4/21/91
 */


typedef struct {
			double	_x0;		/* Initial Conditions */
			double	_lambda;	/* Physical System Parameters */
						/* Above global; below mostly for bbIteration	*/
			int		_HitNumber, _HitInd1, _HitInd2, _RealHitNumber;
			int		_CurHitNumber;
			int		_StuckStatus, _NewStuckStatus;
			double	_xi, _xj;
			double	_ti_Continuing;		/* For Continue Iteration */
			int		_StuckCount;
		}	IterationVars, *pIterationVars;

#define	x0				(pCurrentVars->_x0)
#define	lambda			(pCurrentVars->_lambda)
#define	HitNumber		(pCurrentVars->_HitNumber)
#define	HitInd1			(pCurrentVars->_HitInd1)
#define	HitInd2			(pCurrentVars->_HitInd2)
#define	RealHitNumber	(pCurrentVars->_RealHitNumber)
#define	CurHitNumber	(pCurrentVars->_CurHitNumber)
#define	StuckStatus		(pCurrentVars->_StuckStatus)
#define	NewStuckStatus	(pCurrentVars->_NewStuckStatus)
#define	xi				(pCurrentVars->_xi)
#define	xj				(pCurrentVars->_xj)
#define	ti_Continuing	(pCurrentVars->_ti_Continuing)
#define	StuckCount		(pCurrentVars->_StuckCount)
