/*
 *	qmPhysics.c
 *
 *	Physics-related routines for Quadratic Map
 *
 */

#include "qmPrototypes.h"

double QuadraticMap(double theLambda, double theX)
{
	return(theLambda * theX * (1 - theX));
}

double nQuadMap(int n, double theLambda, double theX)
{
	int		i;
	double	tmpX = theX;

	for(i=1; i<=n; ++i)
		tmpX = QuadraticMap(theLambda, tmpX);
	return(tmpX);
}